% This script shows results describe in the paper:
% On-board correction of systematic errors in differential robots
% S. Maldonado, R. López, F.J. Acevedo, P. Gil
% Submitted to Sensors

% The two figures represented per file are:
% - The distance from the robot to the object while turning as a function
% of the number of the encoder pulses 
% - The autocorrelation of the previous sequence

% Data from experiment are in the files *.m
text_files_R_fix=[...
    'R_fix_1';...
    'R_fix_2';...
    'R_fix_3';...
    'R_fix_4';...
    'R_fix_5'];
text_files_L_fix=[...
    'L_fix_1';...
    'L_fix_2';...
    'L_fix_3';...
    'L_fix_4';...
    'L_fix_5'];
text_files_R_b_2=[...
    'R_b_2_1';...
    'R_b_2_2';...
    'R_b_2_3';...
    'R_b_2_4';...
    'R_b_2_5'];
    
% Estimated Period (just for fast look)
N=955;
% Display the results for the Stopped Left Wheel
P1L=[];
for h=1:5
    eval(text_files_R_fix(h,:));   
    zz=pr2(x);
    pr21
    % Uncomment if you want to save figures
    figure(1)    
    cad=[text_files_R_fix(h,:), '_distance.bmp'];
    print(cad,'-dbmp');
    figure(2)
    cad=[text_files_R_fix(h,:), '_aut.bmp'];
    print(cad,'-dbmp');
    P1L=[P1L Period];
%   pause
end
P1L

% Display the results for the Stopped Left Wheel
P1R=[];
for h=1:5
    eval(text_files_L_fix(h,:));
    zz=pr2(x);
    pr21
    % Uncomment if you want to save figures
    figure(1)
    cad=[text_files_L_fix(h,:), '_distance.bmp'];
    print(cad,'-dbmp');
    figure(2)
    cad=[text_files_L_fix(h,:), '_aut.bmp'];
    print(cad,'-dbmp');
    P1R=[P1R Period];
%    pause
end
P1R

% Estimated Period (just for fast look)
N=480;

% Display results for the turning around the center of axis of the wheels
P0Rb2=[];
for h=1:5
    eval(text_files_R_b_2(h,:));
    zz=pr2(x);
    pr21
    figure(1)
    cad=[text_files_R_b_2(h,:), '_distance.bmp'];
    print(cad,'-dbmp');
    figure(2)
    cad=[text_files_R_b_2(h,:), '_aut.bmp'];
    print(cad,'-dbmp');    
    P0Rb2=[P0Rb2 Period];
%    pause
end
P0Rb2